# include <iostream>
# include "secret.h"

const int MAX=1001;
const int MAX_VALUE=1e9;
int a[MAX];
int tree[MAX*4];
int n;

void build(int v=1, int l=1, int r=n)
{
    if(l==r)
    {
        tree[v]=a[l];
        return ;
    }

    int mid=(l+r)/2;
    build(v*2,l,mid);
    build(v*2+1,mid+1,r);
    tree[v]=Secret(tree[v*2],tree[v*2+1]);
}

int query(int le, int ri, int v=1, int l=1, int r=n)
{
    if(ri<l or r<le) return -1;
    if(le<=l and r<=ri) return tree[v];

    int mid=(l+r)/2;
    int q1=query(le,ri,v*2,l,mid),q2=query(le,ri,v*2+1,mid+1,r);
    if(q1==-1) return q2;
    if(q2==-1) return q1;
    return (q1 + 2 * (q2 / 2) < MAX_VALUE) ? (q1 + 2 * (q2 / 2)) : MAX_VALUE;
}

//Secret(0, 1000000000);

void Init(int N, int A[])
{
    n=N;
    for(int i=1;i<=n;i++)
    {
        a[i]=A[i-1];
    }

    build();
}

int Query(int L ,int R)
{
    int l=L+1,r=R+1;
    return query(l,r);
}
