#include "secret.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 1005;

int n;
int a[maxn];

struct segment_tree
{
    int tree[4 * maxn];

    void build(int node, int l, int r)
    {
        if (l == r)
        {
            tree[node] = a[l];
            return;
        }

        int mid = (l + r) / 2;

        build(2 * node, l, mid);
        build(2 * node + 1, mid + 1, r);

        tree[node] = Secret(tree[2 * node], tree[2 * node + 1]);
    }

    int query(int node, int l, int r, int ql, int qr)
    {
        if (ql <= l && r <= qr)
        {
            return tree[node];
        }

        int mid = (l + r) / 2;

        int result = 0;

        if (ql <= mid)
        {
            result = query(2 * node, l, mid, ql, qr);
        }

        if (qr >= mid + 1)
        {
            if (result == 0)
            {
                result = query(2 * node + 1, mid + 1, r, ql, qr);
            }
            else
            {
                result = Secret(result, query(2 * node + 1, mid + 1, r, ql, qr));
            }
        }

        return result;
    }

    void build()
    {
        build(1, 1, n);
    }

    int query(int l, int r)
    {
        return query(1, 1, n, l, r);
    }
};

segment_tree tree;

void Init(int N, int arr[])
{
     n = N;

     for (int i = 1; i <= n; ++i)
     {
         a[i] = arr[i - 1];
     }

     tree.build();
}

int Query(int l, int r)
{
    ++l;
    ++r;
    return tree.query(l, r);
}
