#include "secret.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 1005;
const int max_log = 11;

int n;
int a[maxn];

int precalc[maxn][max_log];

void divide_and_conquer(int l, int r, int level)
{
    if (l > r)
    {
        return;
    }

    if (l == r)
    {
        precalc[l][level] = a[l];
        return;
    }

    int mid = (l + r) / 2;

    precalc[mid][level] = a[mid];

    for (int i = mid - 1; i >= l; --i)
    {
        precalc[i][level] = Secret(precalc[i + 1][level], a[i]);
    }

    precalc[mid + 1][level] = a[mid + 1];

    for (int i = mid + 2; i <= r; ++i)
    {
        precalc[i][level] = Secret(precalc[i - 1][level], a[i]);
    }

    divide_and_conquer(l, mid, level + 1);
    divide_and_conquer(mid + 1, r, level + 1);
}

int query(int level, int l, int r, int ql, int qr)
{
    if (l == r)
    {
        return precalc[l][level];
    }

    int mid = (l + r) / 2;

    if (qr <= mid)
    {
        return query(level + 1, l, mid, ql, qr);
    }

    if (ql >= mid + 1)
    {
        return query(level + 1, mid + 1, r, ql, qr);
    }

    return Secret(query(level + 1, l, mid, ql, qr), query(level + 1, mid + 1, r, ql, qr));
}

void Init(int N, int arr[])
{
     n = N;

     for (int i = 1; i <= n; ++i)
     {
         a[i] = arr[i - 1];
     }

     divide_and_conquer(1, n, 0);
}

int Query(int l, int r)
{
    ++l;
    ++r;

    return query(0, 1, n, l, r);
}
