#include <cmath>
#include "secret.h"

#define ll long long

ll n;
ll a[1000];
ll pow2[11];
ll pref[257][1000];
ll suf[257][1000];

ll getRange(ll num) {
	ll temp = 1;
	for (ll i = 0; i < 10; i++) {
		temp *= 2;
		if (num % temp != 0) {
			return temp / 2;
			break;
		}
	}
	return 2;
}

void Init(int N, int A[]) {
	ll powOf2 = 1;
	for (ll i = 0; i < 11; i++) {
		pow2[i] = powOf2;
		powOf2 *= 2;
	}

	n = N;
	for (ll i = 0; i < n; i++) {
		a[i] = A[i];
	}

	for (ll i = 0; i < 1000; i += 4) {
		ll range = getRange(i) / 2;
		ll temp = a[i + 1];
		pref[i / 4][i + 1] = temp;
		for (ll j = i + 2; j < i + range; j++) {
			Secret(temp, a[j]);
			pref[i / 4][j] = temp;
		}

		temp = a[i];
		suf[i / 4][i] = temp;
		for (ll j = i - 1; j >= i - range; j--) {
			Secret(a[j], temp);
			suf[i / 4][j] = temp;
		}
	}
}

int Query(int L, int R) {
	if (L == R) {
		return a[L];
	}
	if (L + 1 == R) {
		return Secret(a[L], a[R]);
	}

	if (L + 3 >= R) {
		ll temp = a[L];
		for (ll i = L + 1; i <= R; i++) {
			temp = Secret(temp, a[i]);
		}
		return temp;
	}

	ll temp = pow2[(ll)(log2(L ^ (R - 1)))];
	ll pnt = (L / temp) * temp + temp;
	pnt /= 4;

	return Secret(pref[pnt][L], pref[pnt][R]);
}
